// crypt_demo.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <stdio.h>
#include <io.h>
#include "crypt_demo.h"

// point to the path you have installed the encryption SDK
#include "gogcryptdev.h"
// after you unlock the gogcryptlib use this include
// #include "../gogcryptlib/gogcryptlib.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

HWND g_hWnd;  // main window handle

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

// functions to demonstrate the encryption library
void encrypt_file();
void decrypt_file();

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CRYPT_DEMO, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_CRYPT_DEMO));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CRYPT_DEMO));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_CRYPT_DEMO);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   g_hWnd = hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case ID_FILE_ENCRYPTFILE:
			encrypt_file();
			break;
		case ID_FILE_DECRYPTFILE:
			decrypt_file();
			break;
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}


//
//  FUNCTION: select_file(void)
//
//  PURPOSE:  Opens the file dialog to select a file
//
//
//

char* select_file(void)
{
	OPENFILENAME of;
	static char szFileName[3000] = "";

	ZeroMemory(&of, sizeof(of));

	of.lStructSize = sizeof(of);
	of.hwndOwner = g_hWnd;
	of.lpstrFilter = "All Files(*.*)\0*.*\0";
	of.lpstrFile = szFileName;
	of.nMaxFile = 3000;
	of.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	of.lpstrDefExt = "*";

	if(GetOpenFileName(&of))
	{
		strcpy(szFileName, of.lpstrFile);
		return szFileName;
	}
	return NULL;
}

// size of buffer used for file encryption
const unsigned long ALLOC_SIZE=1024L * 1024L;
// the encryption password
const char* password = "aPassword031";
// 
// 
//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  uses the buffer encryption function to encrypt a file
//
//
//
void encrypt_file()
{
	char* fname = select_file();
	if (!fname)
		return;

	FILE* fp = NULL;
	FILE* ftemp = NULL;
	char tmpname[3000];
	unsigned long len = 0;
	unsigned char* data = (unsigned char*)NULL;

	try
	{
		data = (unsigned char*)new unsigned char[ALLOC_SIZE];

		if (data)
		{
			strcpy(tmpname, fname);
			strcat(tmpname, ".enctmp");
			fp = fopen(fname, "rb");
			ftemp = fopen(tmpname, "wb");
			if (fp && ftemp)
			{
				len = _filelength(_fileno(fp));
				if (len > 0)
				{
					long loops = len / ALLOC_SIZE;
					long reads;
					unsigned long read_size;

					if (loops*ALLOC_SIZE < len)
						loops++;
					read_size = ALLOC_SIZE;

					for (reads=0; reads<loops; reads++)
					{
						if (read_size > len)
							read_size = len;
						len -= read_size;
						fread(data, sizeof(unsigned char), read_size, fp);
						gogEncryptBuff(data, read_size, password);
						fwrite(data, sizeof(unsigned char), read_size, ftemp);
					}
				}
				fclose(fp);
				fclose(ftemp);
				MoveFileEx(tmpname, fname, MOVEFILE_REPLACE_EXISTING|MOVEFILE_COPY_ALLOWED);
			}
			else
			{
				if (fp)
				{
					fclose(fp);
				}
				if (ftemp)
				{
					fclose(ftemp);
				}
			}
		}
	}
	catch(...)
	{
	}

	if (data != NULL)
		delete data;
}

// 
//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  uses the buffer decryption function to decrypt a file
//
//
//
void decrypt_file()
{
	char* fname = select_file();
	if (!fname)
		return;

	FILE* fp = NULL;
	FILE* ftemp = NULL;
	char tmpname[3000];
	unsigned long len = 0;
	unsigned char* data = (unsigned char*)NULL;

	try
	{
		data = (unsigned char*)new unsigned char[ALLOC_SIZE];

		if (data)
		{
			strcpy(tmpname, fname);
			strcat(tmpname, ".enctmp");
			fp = fopen(fname, "rb");
			ftemp = fopen(tmpname, "wb");
			if (fp && ftemp)
			{
				len = _filelength(_fileno(fp));
				if (len > 0)
				{
					long loops = len / ALLOC_SIZE;
					long reads;
					unsigned long read_size;

					if (loops*ALLOC_SIZE < len)
						loops++;
					read_size = ALLOC_SIZE;

					for (reads=0; reads<loops; reads++)
					{
						if (read_size > len)
							read_size = len;
						len -= read_size;
						fread(data, sizeof(unsigned char), read_size, fp);
						gogDecryptBuff(data, read_size, password);
						fwrite(data, sizeof(unsigned char), read_size, ftemp);
					}
				}
				fclose(fp);
				fclose(ftemp);
				MoveFileEx(tmpname, fname, MOVEFILE_REPLACE_EXISTING|MOVEFILE_COPY_ALLOWED);
			}
			else
			{
				if (fp)
				{
					fclose(fp);
				}
				if (ftemp)
				{
					fclose(ftemp);
				}
			}
		}
	}
	catch(...)
	{
	}

	if (data != NULL)
		delete data;
}
